#property copyright "Alphamatic"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color1 Blue 
#property indicator_color2 Blue
#property indicator_color3 Gold 
#property indicator_color4 Gold
#property indicator_color5 Black
#property indicator_color6 Black 
#property indicator_color7 Lime
#property indicator_color8 Red 




#property indicator_width1 1
#property indicator_width2 1

extern int Processed   = 1000;
extern int WIG_Period  = 8;

double direct[];
double direct1[];
double direct2[];
double direct3[];
double reflect[];
double reflect1[];
double reflect2[];
double reflect3[];

double Data[][6];// time, open, close, high, low


int counter;

datetime last_processed_bar =0, curr_processed_bar = 0, trend_start = 0;

#define R_DATA_TIME    0
#define R_DATA_OPEN    1
#define R_DATA_CLOSE   2
#define R_DATA_HIGH    3
#define R_DATA_LOW     4

int init(){
  int idx;
  counter = 0;
  IndicatorDigits(Digits);
  IndicatorShortName	("Reflect");

  SetIndexBuffer(0, direct);  SetIndexStyle(0,DRAW_HISTOGRAM,0,3); 
  SetIndexBuffer(1, direct1);  SetIndexStyle(1,DRAW_HISTOGRAM,0,3); 
  SetIndexBuffer(2, direct2);  SetIndexStyle(2,DRAW_HISTOGRAM,0,3); 
  SetIndexBuffer(3, direct3);  SetIndexStyle(3,DRAW_HISTOGRAM,0,3); 
    
  SetIndexBuffer(4, reflect); SetIndexStyle(4,DRAW_HISTOGRAM,0,3); 
  SetIndexBuffer(5, reflect1); SetIndexStyle(5,DRAW_HISTOGRAM,0,3); 
  SetIndexBuffer(6, reflect2); SetIndexStyle(6,DRAW_HISTOGRAM,0,3); 
  SetIndexBuffer(7, reflect3); SetIndexStyle(7,DRAW_HISTOGRAM,0,3); 
      
  ArrayResize(Data, Processed);
  for (idx = Processed-1; idx >= 0; idx--){
    Data[idx][] = {0.0, 0.0, 0.0, 0.0, 0.0};
  }
  
  return(0);
}

int deinit(){

  return(0);
}


int start(){
  int idx;
  double ha_open, ha_high, ha_low, ha_close;  
  
  if(Bars <= 10) return(0);
  int counted_bars = IndicatorCounted();
  if (counted_bars < 0) return(-1);
  int limit = Bars-counted_bars-1;
  if (limit > Processed){
    limit = Processed;
    last_processed_bar = iTime(NULL, 0, Processed);
  }
  for (idx = limit; idx >= 0; idx -- ){
    curr_processed_bar = iTime(NULL, 0, idx);
    if (last_processed_bar != curr_processed_bar) On_new_bar(curr_processed_bar); 
    
    ha_open  = (Data[1][R_DATA_OPEN]+Data[1][R_DATA_CLOSE])/2;
    ha_close = (2.0*Open[idx]+High[idx]+Low[idx]+5.0*Close[idx])/9.0;
    ha_high  = MathMax(High[idx], MathMax(ha_open, ha_close));
    ha_low   = MathMin(Low[idx],  MathMin(ha_open, ha_close));   
    if (ha_open < ha_close){ 
      Data[0][R_DATA_LOW]  = ha_low;
      Data[0][R_DATA_HIGH] = ha_high;
    } else {
      Data[0][R_DATA_LOW]  = ha_high;
      Data[0][R_DATA_HIGH] = ha_low;   
    }
    Data[0][R_DATA_OPEN]   = ha_open; 
    Data[0][R_DATA_CLOSE]  = ha_close; 
    direct[idx] = ha_low;
    direct1[idx] = ha_high;
    direct2[idx] = ha_open;
    direct3[idx] = ha_close;
  } 
  for (idx = limit; idx >= 0; idx--){
    reflect[idx] = (3.0 * iMAOnArray(direct, 0, WIG_Period, 0, MODE_LWMA, idx) - 2.0 * direct[idx]);       
  }  
  for (idx = limit; idx >= 0; idx--){
    reflect1[idx] = (3.0 * iMAOnArray(direct1, 0, WIG_Period, 0, MODE_LWMA, idx) - 2.0 * direct1[idx]);       
  }  
  for (idx = limit; idx >= 0; idx--){
    reflect2[idx] = (3.0 * iMAOnArray(direct2, 0, WIG_Period, 0, MODE_LWMA, idx) - 2.0 * direct2[idx]);       
  }  
  for (idx = limit; idx >= 0; idx--){
    reflect3[idx] = (3.0 * iMAOnArray(direct3, 0, WIG_Period, 0, MODE_LWMA, idx) - 2.0 *direct3[idx] );       
  }  
  return(0);
}


void On_new_bar(datetime bar_time){
  counter++;
  if (counter > Processed) counter = Processed;
  //   
  int idx;
  //   
  for (idx = Processed-2; idx >= 0; idx--){
    Data[idx+1,0] = Data[idx,0]; 
    Data[idx+1,1] = Data[idx,1];
    Data[idx+1,2] = Data[idx,2];
    Data[idx+1,3] = Data[idx,3];
    Data[idx+1,4] = Data[idx,4]; 
  }
  Data[idx,0] = bar_time;
  last_processed_bar = bar_time;
}

